/*_############################################################################
  _## 
  _##  SNMP4J-AgentJMX - MBeanProxyType.java  
  _## 
  _##  Copyright (C) 2006-2009  Frank Fock (SNMP4J.org)
  _##  
  _##  This program is free software; you can redistribute it and/or modify
  _##  it under the terms of the GNU General Public License version 2 as 
  _##  published by the Free Software Foundation.
  _##
  _##  This program is distributed in the hope that it will be useful,
  _##  but WITHOUT ANY WARRANTY; without even the implied warranty of
  _##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  _##  GNU General Public License for more details.
  _##
  _##  You should have received a copy of the GNU General Public License
  _##  along with this program; if not, write to the Free Software
  _##  Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, 
  _##  MA  02110-1301  USA
  _##  
  _##########################################################################*/
package org.snmp4j.agent.mo.jmx.types;

import javax.management.ObjectName;
import javax.management.MBeanServerConnection;
import javax.management.*;
import javax.management.*;
import javax.management.*;

public class MBeanProxyType extends TypedAttribute {

  private ObjectName objectName;
  private MBeanServerConnection server;
  private String operationName;
  private TypedAttribute proxy;

  public MBeanProxyType(MBeanServerConnection server,
                        ObjectName name,
                        Class type,
                        String operationName, TypedAttribute proxy) {
    super(proxy.getName(), type);
    this.server = server;
    this.objectName = name;
    this.operationName = operationName;
    this.proxy = proxy;
  }

  public Object transformFromNative(Object nativeValue, ObjectName objectName) {
    Object param = proxy.transformFromNative(nativeValue, null);
    try {
      Object result = server.invoke(this.objectName, operationName,
                                    new Object[] {param},
                                    new String[] {proxy.getType().getName()});
      return result;
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
    return null;
  }

  public Object transformToNative(Object transformedValue,
                                  Object oldNativeValue, ObjectName objectName) {
    throw new UnsupportedOperationException();
  }

}
